﻿@inherits LayoutComponentBase
@inject LoginStateService loginStateService
@using Veloverleih.Client.State
@using Veloverleih.Shared
@implements IDisposable

<div class="page">
    <div class="sidebar">
        <NavMenu />
    </div>

    <main>
        <div class="top-row px-4">
            <select name="user" class="form-select" value="@selectedUser" @onchange="ChangeUser">
                @foreach (Users user in Enum.GetValues(typeof(Users)))
                {
                    <option value="@user">@user</option>
                }
            </select>
        </div>

        <article class="content px-4">
            @Body
        </article>
    </main>
</div>

@code
{
    private Users selectedUser;

    protected override async Task OnInitializedAsync()
    {
        loginStateService.OnStateChange += StateHasChanged;
        selectedUser = loginStateService.User;
    }

    void ChangeUser(ChangeEventArgs args)
    {
        var selectedUserAsString = args.Value?.ToString();

        if (string.IsNullOrEmpty(selectedUserAsString)) return;

        loginStateService.SetValue((Users)Enum.Parse(typeof(Users), selectedUserAsString));
    }

    public void Dispose()
    {
        loginStateService.OnStateChange -= StateHasChanged;
    }
}
